apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ printf "proxy-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
  labels:
{{- if .Values.protectedServiceApp }}
    app: "{{ .Values.protectedServiceApp }}"
{{- end }}
    helm.sh/chart: "{{.Chart.Name}}-{{.Chart.Version}}"
    app.kubernetes.io/name: proxy
    app.kubernetes.io/instance: {{ .Release.Name }}
spec:
  selector:
    matchLabels:
      helm.sh/chart: "{{.Chart.Name}}-{{.Chart.Version}}"
      app.kubernetes.io/name: proxy
      app.kubernetes.io/instance: {{ .Release.Name }}
  template:
    metadata:
      labels:
        helm.sh/chart: "{{.Chart.Name}}-{{.Chart.Version}}"
        app.kubernetes.io/name: proxy
        app.kubernetes.io/instance: {{ .Release.Name }}
    spec:
      {{- if .Values.registry.secret.username }}
      imagePullSecrets:
        - name: {{ printf "pull-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
      {{- end }}
      containers:
      - name: {{ include "fullName" . }}-proxy
        image: "{{ .Values.imageRegistry }}/{{ .Values.httpdImage.name }}:{{ .Values.httpdImage.version }}"
        imagePullPolicy: {{ .Values.imagePullPolicy }}
        ports:
        - name: httpd
          containerPort: 8080
          protocol: TCP
        volumeMounts:
        - name: {{ printf "socket-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          mountPath: /var/run/shibboleth
        - name: {{ printf "shconf-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          mountPath: /etc/shibboleth/shibboleth2.xml
          readOnly: true
          subPath: shibboleth2.xml
        - name: {{ printf "apconf-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          mountPath: /etc/httpd/conf.d/servername.conf
          readOnly: true
          subPath: servername.conf
        {{- if .Values.applicationConfiguration }}
        - name: {{ printf "apconf-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          mountPath: /etc/httpd/conf.d/application.conf
          readOnly: true
          subPath: application.conf
        {{- end }}
      - name: {{ .Chart.Name }}-shibd
        image: "{{ .Values.imageRegistry }}/{{ .Values.shibbolethImage.name }}:{{ .Values.shibbolethImage.version }}"
        imagePullPolicy: Always
        volumeMounts:
        - name: {{ printf "socket-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          mountPath: /var/run/shibboleth
        - name: {{ printf "shconf-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          mountPath: /etc/shibboleth/shibboleth2.xml
          readOnly: true
          subPath: shibboleth2.xml
        {{- if .Values.shibboleth.attributeMap }}
        - name: {{ printf "shconf-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          mountPath: /etc/shibboleth/attribute-map.xml
          readOnly: true
          subPath: attribute-map.xml
        {{- end }}
        - name: {{ printf "spcreds-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          mountPath: /etc/shibboleth/tls.key
          readOnly: true
          subPath: tls.key
        - name: {{ printf "spcreds-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          mountPath: /etc/shibboleth/tls.crt
          readOnly: true
          subPath: tls.crt
      volumes:
      - name: {{ printf "apconf-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
        configMap:
          name: {{ printf "apconf-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          defaultMode: 420
      - name: {{ printf "shconf-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
        configMap:
          name: {{ printf "shconf-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          defaultMode: 420
          items:
            - key: shibboleth2.xml
              path: shibboleth2.xml
          {{- if .Values.shibboleth.attributeMap }}
            - key: atrribute-map.xml
              path: attribute-map.xml
          {{- end }}
      - name: {{ printf "spcreds-%s" .Release.Name | trunc 63 | trimSuffix "-" }} 
        secret:
          secretName: {{ printf "spcreds-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
          defaultMode: 420
      - name: {{ printf "socket-%s" .Release.Name | trunc 63 | trimSuffix "-" }}
        emptyDir: {}
